// Code generated by go-swagger; DO NOT EDIT.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"context"
	"net/http"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	"github.com/openclarity/kubeclarity/api/server/models"
)

// GetPackagesHandlerFunc turns a function with the right signature into a get packages handler
type GetPackagesHandlerFunc func(GetPackagesParams) middleware.Responder

// Handle executing the request and returning a response
func (fn GetPackagesHandlerFunc) Handle(params GetPackagesParams) middleware.Responder {
	return fn(params)
}

// GetPackagesHandler interface for that can handle valid get packages params
type GetPackagesHandler interface {
	Handle(GetPackagesParams) middleware.Responder
}

// NewGetPackages creates a new http.Handler for the get packages operation
func NewGetPackages(ctx *middleware.Context, handler GetPackagesHandler) *GetPackages {
	return &GetPackages{Context: ctx, Handler: handler}
}

/* GetPackages swagger:route GET /packages getPackages

Get packages

*/
type GetPackages struct {
	Context *middleware.Context
	Handler GetPackagesHandler
}

func (o *GetPackages) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		*r = *rCtx
	}
	var Params = NewGetPackagesParams()
	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params) // actually handle the request
	o.Context.Respond(rw, r, route.Produces, route, res)

}

// GetPackagesOKBody get packages o k body
//
// swagger:model GetPackagesOKBody
type GetPackagesOKBody struct {

	// List of packages in the given filters and page. List length must be lower or equal to pageSize
	Items []*models.Package `json:"items"`

	// Total packages count under the given filters
	// Required: true
	Total *int64 `json:"total"`
}

// Validate validates this get packages o k body
func (o *GetPackagesOKBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateItems(formats); err != nil {
		res = append(res, err)
	}

	if err := o.validateTotal(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetPackagesOKBody) validateItems(formats strfmt.Registry) error {
	if swag.IsZero(o.Items) { // not required
		return nil
	}

	for i := 0; i < len(o.Items); i++ {
		if swag.IsZero(o.Items[i]) { // not required
			continue
		}

		if o.Items[i] != nil {
			if err := o.Items[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("getPackagesOK" + "." + "items" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (o *GetPackagesOKBody) validateTotal(formats strfmt.Registry) error {

	if err := validate.Required("getPackagesOK"+"."+"total", "body", o.Total); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this get packages o k body based on the context it is used
func (o *GetPackagesOKBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := o.contextValidateItems(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetPackagesOKBody) contextValidateItems(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(o.Items); i++ {

		if o.Items[i] != nil {
			if err := o.Items[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("getPackagesOK" + "." + "items" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetPackagesOKBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetPackagesOKBody) UnmarshalBinary(b []byte) error {
	var res GetPackagesOKBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
